import './api.dart';

/// Account class
class Account {
  /// API class
  API _api;

  /// Account
  Account(API api) {
    this._api = api;
  }

  toString() {
    return 'Account';
  }

  /// Ban
  Future<Map> ban([Map<String, String> params]) async {
    return this._api.request('account.ban', {
      ...?params,
    });
  }

  /// Change Password
  Future<Map> changePassword([Map<String, String> params]) async {
    return this._api.request('account.changePassword', {
      ...?params,
    });
  }

  /// Get Active Offers
  Future<Map> getActiveOffers([Map<String, String> params]) async {
    return this._api.request('account.getActiveOffers', {
      ...?params,
    });
  }

  /// Get App Permissions
  Future<Map> getAppPermissions([Map<String, String> params]) async {
    return this._api.request('account.getAppPermissions', {
      ...?params,
    });
  }

  /// Get Banned
  Future<Map> getBanned([Map<String, String> params]) async {
    return this._api.request('account.getBanned', {
      ...?params,
    });
  }

  /// Get Counters
  Future<Map> getCounters([Map<String, String> params]) async {
    return this._api.request('account.getCounters', {
      ...?params,
    });
  }

  /// Get Info
  Future<Map> getInfo([Map<String, String> params]) async {
    return this._api.request('account.getInfo', {
      ...?params,
    });
  }

  /// Get Profile Info
  Future<Map> getProfileInfo([Map<String, String> params]) async {
    return this._api.request('account.getProfileInfo', {
      ...?params,
    });
  }

  /// Get Push Settings
  Future<Map> getPushSettings([Map<String, String> params]) async {
    return this._api.request('account.getPushSettings', {
      ...?params,
    });
  }

  /// Register Device
  Future<Map> registerDevice([Map<String, String> params]) async {
    return this._api.request('account.registerDevice', {
      ...?params,
    });
  }

  /// Save Profile Info
  Future<Map> saveProfileInfo([Map<String, String> params]) async {
    return this._api.request('account.saveProfileInfo', {
      ...?params,
    });
  }

  /// Set Info
  Future<Map> setInfo([Map<String, String> params]) async {
    return this._api.request('account.setInfo', {
      ...?params,
    });
  }

  /// Set Name In Menu
  Future<Map> setNameInMenu([Map<String, String> params]) async {
    return this._api.request('account.setNameInMenu', {
      ...?params,
    });
  }

  /// Set Offline
  Future<Map> setOffline([Map<String, String> params]) async {
    return this._api.request('account.setOffline', {
      ...?params,
    });
  }

  /// Set Online
  Future<Map> setOnline([Map<String, String> params]) async {
    return this._api.request('account.setOnline', {
      ...?params,
    });
  }

  /// Set Push Settings
  Future<Map> setPushSettings([Map<String, String> params]) async {
    return this._api.request('account.setPushSettings', {
      ...?params,
    });
  }

  /// Set Silence Mode
  Future<Map> setSilenceMode([Map<String, String> params]) async {
    return this._api.request('account.setSilenceMode', {
      ...?params,
    });
  }

  /// Unban
  Future<Map> unban([Map<String, String> params]) async {
    return this._api.request('account.unban', {
      ...?params,
    });
  }

  /// Unregister Device
  Future<Map> unregisterDevice([Map<String, String> params]) async {
    return this._api.request('account.unregisterDevice', {
      ...?params,
    });
  }
}
