import './api.dart';

/// Ads class
class Ads {
  /// API class
  API _api;

  /// Ads
  Ads(API api) {
    this._api = api;
  }

  toString() {
    return 'Ads';
  }

  /// Add Office Users
  Future<Map> addOfficeUsers([Map<String, String> params]) async {
    return this._api.request('ads.addOfficeUsers', {
      ...?params,
    });
  }

  /// Check Link
  Future<Map> checkLink([Map<String, String> params]) async {
    return this._api.request('ads.checkLink', {
      ...?params,
    });
  }

  /// Create Ads
  Future<Map> createAds([Map<String, String> params]) async {
    return this._api.request('ads.createAds', {
      ...?params,
    });
  }

  /// Create Campaigns
  Future<Map> createCampaigns([Map<String, String> params]) async {
    return this._api.request('ads.createCampaigns', {
      ...?params,
    });
  }

  /// Create Clients
  Future<Map> createClients([Map<String, String> params]) async {
    return this._api.request('ads.createClients', {
      ...?params,
    });
  }

  /// Create Lookalike Request
  Future<Map> createLookalikeRequest([Map<String, String> params]) async {
    return this._api.request('ads.createLookalikeRequest', {
      ...?params,
    });
  }

  /// Create Target Group
  Future<Map> createTargetGroup([Map<String, String> params]) async {
    return this._api.request('ads.createTargetGroup', {
      ...?params,
    });
  }

  /// Create Target Pixel
  Future<Map> createTargetPixel([Map<String, String> params]) async {
    return this._api.request('ads.createTargetPixel', {
      ...?params,
    });
  }

  /// Delete Ads
  Future<Map> deleteAds([Map<String, String> params]) async {
    return this._api.request('ads.deleteAds', {
      ...?params,
    });
  }

  /// Delete Campaigns
  Future<Map> deleteCampaigns([Map<String, String> params]) async {
    return this._api.request('ads.deleteCampaigns', {
      ...?params,
    });
  }

  /// Delete Clients
  Future<Map> deleteClients([Map<String, String> params]) async {
    return this._api.request('ads.deleteClients', {
      ...?params,
    });
  }

  /// Delete Target Group
  Future<Map> deleteTargetGroup([Map<String, String> params]) async {
    return this._api.request('ads.deleteTargetGroup', {
      ...?params,
    });
  }

  /// Delete Target Pixel
  Future<Map> deleteTargetPixel([Map<String, String> params]) async {
    return this._api.request('ads.deleteTargetPixel', {
      ...?params,
    });
  }

  /// Get Accounts
  Future<Map> getAccounts([Map<String, String> params]) async {
    return this._api.request('ads.getAccounts', {
      ...?params,
    });
  }

  /// Get Ads
  Future<Map> getAds([Map<String, String> params]) async {
    return this._api.request('ads.getAds', {
      ...?params,
    });
  }

  /// Get Ads Layout
  Future<Map> getAdsLayout([Map<String, String> params]) async {
    return this._api.request('ads.getAdsLayout', {
      ...?params,
    });
  }

  /// Get Ads Targeting
  Future<Map> getAdsTargeting([Map<String, String> params]) async {
    return this._api.request('ads.getAdsTargeting', {
      ...?params,
    });
  }

  /// Get Budget
  Future<Map> getBudget([Map<String, String> params]) async {
    return this._api.request('ads.getBudget', {
      ...?params,
    });
  }

  /// Get Campaigns
  Future<Map> getCampaigns([Map<String, String> params]) async {
    return this._api.request('ads.getCampaigns', {
      ...?params,
    });
  }

  /// Get Categories
  Future<Map> getCategories([Map<String, String> params]) async {
    return this._api.request('ads.getCategories', {
      ...?params,
    });
  }

  /// Get Clients
  Future<Map> getClients([Map<String, String> params]) async {
    return this._api.request('ads.getClients', {
      ...?params,
    });
  }

  /// Get Demographics
  Future<Map> getDemographics([Map<String, String> params]) async {
    return this._api.request('ads.getDemographics', {
      ...?params,
    });
  }

  /// Get Flood Stats
  Future<Map> getFloodStats([Map<String, String> params]) async {
    return this._api.request('ads.getFloodStats', {
      ...?params,
    });
  }

  /// Get Lookalike Requests
  Future<Map> getLookalikeRequests([Map<String, String> params]) async {
    return this._api.request('ads.getLookalikeRequests', {
      ...?params,
    });
  }

  /// Get Office Users
  Future<Map> getOfficeUsers([Map<String, String> params]) async {
    return this._api.request('ads.getOfficeUsers', {
      ...?params,
    });
  }

  /// Get Posts Reach
  Future<Map> getPostsReach([Map<String, String> params]) async {
    return this._api.request('ads.getPostsReach', {
      ...?params,
    });
  }

  /// Get Rejection Reason
  Future<Map> getRejectionReason([Map<String, String> params]) async {
    return this._api.request('ads.getRejectionReason', {
      ...?params,
    });
  }

  /// Get Statistics
  Future<Map> getStatistics([Map<String, String> params]) async {
    return this._api.request('ads.getStatistics', {
      ...?params,
    });
  }

  /// Get Suggestions
  Future<Map> getSuggestions([Map<String, String> params]) async {
    return this._api.request('ads.getSuggestions', {
      ...?params,
    });
  }

  /// Get Target Groups
  Future<Map> getTargetGroups([Map<String, String> params]) async {
    return this._api.request('ads.getTargetGroups', {
      ...?params,
    });
  }

  /// Get Target Pixels
  Future<Map> getTargetPixels([Map<String, String> params]) async {
    return this._api.request('ads.getTargetPixels', {
      ...?params,
    });
  }

  /// Get Targeting Stats
  Future<Map> getTargetingStats([Map<String, String> params]) async {
    return this._api.request('ads.getTargetingStats', {
      ...?params,
    });
  }

  /// Get Upload Url
  Future<Map> getUploadURL([Map<String, String> params]) async {
    return this._api.request('ads.getUploadURL', {
      ...?params,
    });
  }

  /// Get Video Upload Url
  Future<Map> getVideoUploadURL([Map<String, String> params]) async {
    return this._api.request('ads.getVideoUploadURL', {
      ...?params,
    });
  }

  /// Import Target Contacts
  Future<Map> importTargetContacts([Map<String, String> params]) async {
    return this._api.request('ads.importTargetContacts', {
      ...?params,
    });
  }

  /// Remove Office Users
  Future<Map> removeOfficeUsers([Map<String, String> params]) async {
    return this._api.request('ads.removeOfficeUsers', {
      ...?params,
    });
  }

  /// Remove Target Contacts
  Future<Map> removeTargetContacts([Map<String, String> params]) async {
    return this._api.request('ads.removeTargetContacts', {
      ...?params,
    });
  }

  /// Save Lookalike Request Result
  Future<Map> saveLookalikeRequestResult([Map<String, String> params]) async {
    return this._api.request('ads.saveLookalikeRequestResult', {
      ...?params,
    });
  }

  /// Share Target Group
  Future<Map> shareTargetGroup([Map<String, String> params]) async {
    return this._api.request('ads.shareTargetGroup', {
      ...?params,
    });
  }

  /// Update Ads
  Future<Map> updateAds([Map<String, String> params]) async {
    return this._api.request('ads.updateAds', {
      ...?params,
    });
  }

  /// Update Campaigns
  Future<Map> updateCampaigns([Map<String, String> params]) async {
    return this._api.request('ads.updateCampaigns', {
      ...?params,
    });
  }

  /// Update Clients
  Future<Map> updateClients([Map<String, String> params]) async {
    return this._api.request('ads.updateClients', {
      ...?params,
    });
  }

  /// Update Target Group
  Future<Map> updateTargetGroup([Map<String, String> params]) async {
    return this._api.request('ads.updateTargetGroup', {
      ...?params,
    });
  }

  /// Update Target Pixel
  Future<Map> updateTargetPixel([Map<String, String> params]) async {
    return this._api.request('ads.updateTargetPixel', {
      ...?params,
    });
  }
}
