import './api.dart';

/// Groups class
class Groups {
  /// API class
  API _api;

  /// Groups
  Groups(API api) {
    this._api = api;
  }

  toString() {
    return 'Groups';
  }

  /// Add Address
  Future<Map> addAddress([Map<String, String> params]) async {
    return this._api.request('groups.addAddress', {
      ...?params,
    });
  }

  /// Add Callback Server
  Future<Map> addCallbackServer([Map<String, String> params]) async {
    return this._api.request('groups.addCallbackServer', {
      ...?params,
    });
  }

  /// Add Link
  Future<Map> addLink([Map<String, String> params]) async {
    return this._api.request('groups.addLink', {
      ...?params,
    });
  }

  /// Approve Request
  Future<Map> approveRequest([Map<String, String> params]) async {
    return this._api.request('groups.approveRequest', {
      ...?params,
    });
  }

  /// Ban
  Future<Map> ban([Map<String, String> params]) async {
    return this._api.request('groups.ban', {
      ...?params,
    });
  }

  /// Create
  Future<Map> create([Map<String, String> params]) async {
    return this._api.request('groups.create', {
      ...?params,
    });
  }

  /// Delete Address
  Future<Map> deleteAddress([Map<String, String> params]) async {
    return this._api.request('groups.deleteAddress', {
      ...?params,
    });
  }

  /// Delete Callback Server
  Future<Map> deleteCallbackServer([Map<String, String> params]) async {
    return this._api.request('groups.deleteCallbackServer', {
      ...?params,
    });
  }

  /// Delete Link
  Future<Map> deleteLink([Map<String, String> params]) async {
    return this._api.request('groups.deleteLink', {
      ...?params,
    });
  }

  /// Disable Online
  Future<Map> disableOnline([Map<String, String> params]) async {
    return this._api.request('groups.disableOnline', {
      ...?params,
    });
  }

  /// Edit
  Future<Map> edit([Map<String, String> params]) async {
    return this._api.request('groups.edit', {
      ...?params,
    });
  }

  /// Edit Address
  Future<Map> editAddress([Map<String, String> params]) async {
    return this._api.request('groups.editAddress', {
      ...?params,
    });
  }

  /// Edit Callback Server
  Future<Map> editCallbackServer([Map<String, String> params]) async {
    return this._api.request('groups.editCallbackServer', {
      ...?params,
    });
  }

  /// Edit Link
  Future<Map> editLink([Map<String, String> params]) async {
    return this._api.request('groups.editLink', {
      ...?params,
    });
  }

  /// Edit Manager
  Future<Map> editManager([Map<String, String> params]) async {
    return this._api.request('groups.editManager', {
      ...?params,
    });
  }

  /// Enable Online
  Future<Map> enableOnline([Map<String, String> params]) async {
    return this._api.request('groups.enableOnline', {
      ...?params,
    });
  }

  /// Get
  Future<Map> get([Map<String, String> params]) async {
    return this._api.request('groups.get', {
      ...?params,
    });
  }

  /// Get Addresses
  Future<Map> getAddresses([Map<String, String> params]) async {
    return this._api.request('groups.getAddresses', {
      ...?params,
    });
  }

  /// Get Banned
  Future<Map> getBanned([Map<String, String> params]) async {
    return this._api.request('groups.getBanned', {
      ...?params,
    });
  }

  /// Get By
  Future<Map> getById([Map<String, String> params]) async {
    return this._api.request('groups.getById', {
      ...?params,
    });
  }

  /// Get Callback Confirmation Code
  Future<Map> getCallbackConfirmationCode([Map<String, String> params]) async {
    return this._api.request('groups.getCallbackConfirmationCode', {
      ...?params,
    });
  }

  /// Get Callback Servers
  Future<Map> getCallbackServers([Map<String, String> params]) async {
    return this._api.request('groups.getCallbackServers', {
      ...?params,
    });
  }

  /// Get Callback Settings
  Future<Map> getCallbackSettings([Map<String, String> params]) async {
    return this._api.request('groups.getCallbackSettings', {
      ...?params,
    });
  }

  /// Get Catalog
  Future<Map> getCatalog([Map<String, String> params]) async {
    return this._api.request('groups.getCatalog', {
      ...?params,
    });
  }

  /// Get Catalog Info
  Future<Map> getCatalogInfo([Map<String, String> params]) async {
    return this._api.request('groups.getCatalogInfo', {
      ...?params,
    });
  }

  /// Get Invited Users
  Future<Map> getInvitedUsers([Map<String, String> params]) async {
    return this._api.request('groups.getInvitedUsers', {
      ...?params,
    });
  }

  /// Get Invites
  Future<Map> getInvites([Map<String, String> params]) async {
    return this._api.request('groups.getInvites', {
      ...?params,
    });
  }

  /// Get Long Poll Server
  Future<Map> getLongPollServer([Map<String, String> params]) async {
    return this._api.request('groups.getLongPollServer', {
      ...?params,
    });
  }

  /// Get Long Poll Settings
  Future<Map> getLongPollSettings([Map<String, String> params]) async {
    return this._api.request('groups.getLongPollSettings', {
      ...?params,
    });
  }

  /// Get Members
  Future<Map> getMembers([Map<String, String> params]) async {
    return this._api.request('groups.getMembers', {
      ...?params,
    });
  }

  /// Get Online Status
  Future<Map> getOnlineStatus([Map<String, String> params]) async {
    return this._api.request('groups.getOnlineStatus', {
      ...?params,
    });
  }

  /// Get Requests
  Future<Map> getRequests([Map<String, String> params]) async {
    return this._api.request('groups.getRequests', {
      ...?params,
    });
  }

  /// Get Settings
  Future<Map> getSettings([Map<String, String> params]) async {
    return this._api.request('groups.getSettings', {
      ...?params,
    });
  }

  /// Get Token Permissions
  Future<Map> getTokenPermissions([Map<String, String> params]) async {
    return this._api.request('groups.getTokenPermissions', {
      ...?params,
    });
  }

  /// Invite
  Future<Map> invite([Map<String, String> params]) async {
    return this._api.request('groups.invite', {
      ...?params,
    });
  }

  /// Is Member
  Future<Map> isMember([Map<String, String> params]) async {
    return this._api.request('groups.isMember', {
      ...?params,
    });
  }

  /// Join
  Future<Map> join([Map<String, String> params]) async {
    return this._api.request('groups.join', {
      ...?params,
    });
  }

  /// Leave
  Future<Map> leave([Map<String, String> params]) async {
    return this._api.request('groups.leave', {
      ...?params,
    });
  }

  /// Remove User
  Future<Map> removeUser([Map<String, String> params]) async {
    return this._api.request('groups.removeUser', {
      ...?params,
    });
  }

  /// Reorder Link
  Future<Map> reorderLink([Map<String, String> params]) async {
    return this._api.request('groups.reorderLink', {
      ...?params,
    });
  }

  /// Search
  Future<Map> search([Map<String, String> params]) async {
    return this._api.request('groups.search', {
      ...?params,
    });
  }

  /// Set Callback Settings
  Future<Map> setCallbackSettings([Map<String, String> params]) async {
    return this._api.request('groups.setCallbackSettings', {
      ...?params,
    });
  }

  /// Set Long Poll Settings
  Future<Map> setLongPollSettings([Map<String, String> params]) async {
    return this._api.request('groups.setLongPollSettings', {
      ...?params,
    });
  }

  /// Unban
  Future<Map> unban([Map<String, String> params]) async {
    return this._api.request('groups.unban', {
      ...?params,
    });
  }
}
