import 'dart:math';

import './api.dart';

Random random = new Random();

/// Messages class
class Messages {
  /// API class
  API _api;

  /// Messages
  Messages(API api) {
    this._api = api;
  }

  toString() {
    return 'Messages';
  }

  /// Add Chat User
  Future<Map> addChatUser([Map<String, String> params]) async {
    return this._api.request('messages.addChatUser', {
      ...?params,
    });
  }

  /// Allow Messages From Group
  Future<Map> allowMessagesFromGroup([Map<String, String> params]) async {
    return this._api.request('messages.allowMessagesFromGroup', {
      ...?params,
    });
  }

  /// Create Chat
  Future<Map> createChat([Map<String, String> params]) async {
    return this._api.request('messages.createChat', {
      ...?params,
    });
  }

  /// Delete
  Future<Map> delete([Map<String, String> params]) async {
    return this._api.request('messages.delete', {
      ...?params,
    });
  }

  /// Delete Chat Photo
  Future<Map> deleteChatPhoto([Map<String, String> params]) async {
    return this._api.request('messages.deleteChatPhoto', {
      ...?params,
    });
  }

  /// Delete Conversation
  Future<Map> deleteConversation([Map<String, String> params]) async {
    return this._api.request('messages.deleteConversation', {
      ...?params,
    });
  }

  /// Deny Messages From Group
  Future<Map> denyMessagesFromGroup([Map<String, String> params]) async {
    return this._api.request('messages.denyMessagesFromGroup', {
      ...?params,
    });
  }

  /// Edit
  Future<Map> edit([Map<String, String> params]) async {
    return this._api.request('messages.edit', {
      ...?params,
    });
  }

  /// Edit Chat
  Future<Map> editChat([Map<String, String> params]) async {
    return this._api.request('messages.editChat', {
      ...?params,
    });
  }

  /// Get By Conversation Message
  Future<Map> getByConversationMessageId([Map<String, String> params]) async {
    return this._api.request('messages.getByConversationMessageId', {
      ...?params,
    });
  }

  /// Get By
  Future<Map> getById([Map<String, String> params]) async {
    return this._api.request('messages.getById', {
      ...?params,
    });
  }

  /// Get Chat
  Future<Map> getChat([Map<String, String> params]) async {
    return this._api.request('messages.getChat', {
      ...?params,
    });
  }

  /// Get Chat Preview
  Future<Map> getChatPreview([Map<String, String> params]) async {
    return this._api.request('messages.getChatPreview', {
      ...?params,
    });
  }

  /// Get Conversation Members
  Future<Map> getConversationMembers([Map<String, String> params]) async {
    return this._api.request('messages.getConversationMembers', {
      ...?params,
    });
  }

  /// Get Conversations
  Future<Map> getConversations([Map<String, String> params]) async {
    return this._api.request('messages.getConversations', {
      ...?params,
    });
  }

  /// Get Conversations By
  Future<Map> getConversationsById([Map<String, String> params]) async {
    return this._api.request('messages.getConversationsById', {
      ...?params,
    });
  }

  /// Get History
  Future<Map> getHistory([Map<String, String> params]) async {
    return this._api.request('messages.getHistory', {
      ...?params,
    });
  }

  /// Get History Attachments
  Future<Map> getHistoryAttachments([Map<String, String> params]) async {
    return this._api.request('messages.getHistoryAttachments', {
      ...?params,
    });
  }

  /// Get Important Messages
  Future<Map> getImportantMessages([Map<String, String> params]) async {
    return this._api.request('messages.getImportantMessages', {
      ...?params,
    });
  }

  /// Get Invite Link
  Future<Map> getInviteLink([Map<String, String> params]) async {
    return this._api.request('messages.getInviteLink', {
      ...?params,
    });
  }

  /// Get Last Activity
  Future<Map> getLastActivity([Map<String, String> params]) async {
    return this._api.request('messages.getLastActivity', {
      ...?params,
    });
  }

  /// Get Long Poll History
  Future<Map> getLongPollHistory([Map<String, String> params]) async {
    return this._api.request('messages.getLongPollHistory', {
      ...?params,
    });
  }

  /// Get Long Poll Server
  Future<Map> getLongPollServer([Map<String, String> params]) async {
    return this._api.request('messages.getLongPollServer', {
      ...?params,
    });
  }

  /// Is Messages From Group Allowed
  Future<Map> isMessagesFromGroupAllowed([Map<String, String> params]) async {
    return this._api.request('messages.isMessagesFromGroupAllowed', {
      ...?params,
    });
  }

  /// Join Chat By Invite Link
  Future<Map> joinChatByInviteLink([Map<String, String> params]) async {
    return this._api.request('messages.joinChatByInviteLink', {
      ...?params,
    });
  }

  /// Mark As Answered Conversation
  Future<Map> markAsAnsweredConversation([Map<String, String> params]) async {
    return this._api.request('messages.markAsAnsweredConversation', {
      ...?params,
    });
  }

  /// Mark As Important
  Future<Map> markAsImportant([Map<String, String> params]) async {
    return this._api.request('messages.markAsImportant', {
      ...?params,
    });
  }

  /// Mark As Important Conversation
  Future<Map> markAsImportantConversation([Map<String, String> params]) async {
    return this._api.request('messages.markAsImportantConversation', {
      ...?params,
    });
  }

  /// Mark As Read
  Future<Map> markAsRead([Map<String, String> params]) async {
    return this._api.request('messages.markAsRead', {
      ...?params,
    });
  }

  /// Pin
  Future<Map> pin([Map<String, String> params]) async {
    return this._api.request('messages.pin', {
      ...?params,
    });
  }

  /// Remove Chat User
  Future<Map> removeChatUser([Map<String, String> params]) async {
    return this._api.request('messages.removeChatUser', {
      ...?params,
    });
  }

  /// Restore
  Future<Map> restore([Map<String, String> params]) async {
    return this._api.request('messages.restore', {
      ...?params,
    });
  }

  /// Search
  Future<Map> search([Map<String, String> params]) async {
    return this._api.request('messages.search', {
      ...?params,
    });
  }

  /// Search Conversations
  Future<Map> searchConversations([Map<String, String> params]) async {
    return this._api.request('messages.searchConversations', {
      ...?params,
    });
  }

  /// Send
  Future<Map> send([Map<String, String> params]) async {
    return this._api.request('messages.send', {
      'random_id': random.nextInt(2147483647).toString(),
      ...?params,
    });
  }

  /// Set Activity
  Future<Map> setActivity([Map<String, String> params]) async {
    return this._api.request('messages.setActivity', {
      ...?params,
    });
  }

  /// Set Chat Photo
  Future<Map> setChatPhoto([Map<String, String> params]) async {
    return this._api.request('messages.setChatPhoto', {
      ...?params,
    });
  }

  /// Unpin
  Future<Map> unpin([Map<String, String> params]) async {
    return this._api.request('messages.unpin', {
      ...?params,
    });
  }
}
